
module clock
(

input hour,
input min_a,
input min_d,
input clk_1ms,
input clk_500ms,
input rst_n,
output reg [7:0] hour_out,min_out,
output reg uart_en

);
reg[7:0] hour_mem,min_mem,hour_set,min_set;
reg[15:0] second;

always @(posedge clk_500ms or negedge rst_n) begin
		  if(!rst_n) begin		
				hour_set = 0;
				min_set  = 0;
		  end else  begin
			  if(hour == 0&&min_a == 0&&min_d == 0)
				 begin
				  hour_set = 0;
				  min_set = 0;
				  end
			else if(hour == 0)
				 begin
				  hour_set = hour_out;
				  min_set = min_out;
				  hour_set = hour_set+1'b1;
				  end
			 else if(min_a == 0)
				 begin
				  hour_set = hour_out;
				  min_set = min_out;
				  min_set = min_set+1'b1;
				  end
			 else if(min_d == 0)
				 begin
				  hour_set = hour_out;
				  min_set = min_out;
				  min_set = min_set-1'b1;
				  end
			 if(hour_set == 8'd24)
				 hour_set = 1'b0;
			 if(hour_set > 8'd24)
				 hour_set = 8'd23;
			 if(min_set == 8'd60)
				 min_set = 1'b0;
			 if(min_set > 8'd60)
				 min_set = 8'd59;
		 end
	 end
	 
always @(posedge clk_1ms or negedge rst_n) begin
		  if(!rst_n) begin
			  min_out=0;
			  hour_out=0;
			  uart_en  = 0;
			  hour_mem = 0;
			  min_mem  = 0;
			  second   = 0;
		  end  else begin 
		if(uart_en == 1'b1)
			uart_en = 1'b0;
		if(hour_set != hour_mem || min_set != min_mem)
			begin
				hour_mem = hour_set;
				min_mem = min_set;
				hour_out = hour_set;
				min_out = min_set;
			end
		else
			begin
			  if(second < 16'd60000)
				  second = second+1'b1;
			  else
				  begin
					min_out = min_out+1'b1;
					second = 1'b0;
					if(min_out == 8'd60)
						begin
						 hour_out = hour_out+1'b1;
						 min_out = 1'b0;
						 uart_en = 1'b1;
						 if(hour_out == 8'd24)
							 begin
							  hour_out = 1'b0;
							  end
						 end
					end
			  end  
		 end
	 
	 end
endmodule
