module lf_project
(
	input				clk,		// 12MHzϵͳʱ
	input				rst_n,		// //ϵͳλЧ
	inout				one_wire,	// ds18b20zź
	input 				hour,       //Сʱ
	input			    min_a,		//ӼӰ
	input				min_d,      //Ӽ
	input				uart_in,    //rx
	output				oled_csn,	//OLCDҺʹ
	output				oled_rst,	//OLCDҺλ
	output			    oled_dcn,	//OLCDָ
	output				oled_clk,	//OLCDʱź
	output			    oled_dat,	//OLCDź
	output  	reg		R1,         //е  ʼ״̬Ϩ
	output   	reg		G1,
	output   			B1,
	output   	reg		R2,
	output   	reg		G2,
	output   	reg		B2,
	output reg[7:0]     L,
	output				beeper,    //
	output 				uart_out   //
);

always@( negedge rst_n) begin
	if(!rst_n) begin
		 R1<=1'b1;	  //زʹõƹر
		 G1<=1'b1; 
		 R2<=1'b1; 
		 G2<=1'b1; 
		 B2<=1'b1;	
		 L[7:0]<=8'hff;	
	end
end

//DS18B20ȡ¶*************************************************************
wire	[15:0]	data_out;
DS18B20Z DS18B20Z_lf
(
.clk					(clk			),	// 12MHzϵͳʱ
.rst_n					(rst_n			),	// ϵͳλЧ
.one_wire				(one_wire		),	// ds18b20
.data_out				(data_out		)	// ds18b20
);
// ж¶ȷ
wire [3:0] temperature_flag = data_out[15:11]? 4'h0:4'h1;
// ȡ¶
wire [10:0] temperature_code = temperature_flag? data_out[10:0]:(~data_out[10:0])+1'b1; 
// ת¶ȵBCD****************************************************************
wire [20:0] bin_code = temperature_code * 16'd625;
wire [24:0] bcd_code; //ʮλ[23:20],λ[19:16],Сλ[14:12]
bin_to_bcd bin_to_bcd_lf
(
.rst_n					(rst_n			),	// ϵͳλЧ
.bin_code				(bin_code		),	// bin
.bcd_code				(bcd_code		)	// bcd
);
//תСʱBCD******************************************************************
wire [7:0] hour_out,min_out;//Сʱź
wire [20:0] bin_hour =hour_out*10000;
wire [24:0] bcd_hour;
bin_to_bcd bin_to_bcd_hour
(
.rst_n					(rst_n			),	// ϵͳλЧ
.bin_code				(bin_hour		),	// bin
.bcd_code				(bcd_hour		)	// bcd
);
//תӵBCD******************************************************************
wire [20:0] bin_min =min_out*10000;
wire [24:0] bcd_min;
bin_to_bcd bin_to_bcd_min
(
.rst_n					(rst_n			),	// ϵͳλЧ
.bin_code				(bin_min		),	// bin
.bcd_code				(bcd_min		)	// bcd
);
//oled********************************************************************************
wire display_flag;
OLED12832   OLED12832_lf
(
.clk			(clk						),//12MHzϵͳʱ
.rst_n			(rst_n						),//ϵͳλЧ
.display_flag   ( display_flag 				),//ʾ
.hour_g	   	 	(bcd_hour[19:16]			),//Сʱλ
.hour_s			(bcd_hour[23:20]			),//Сʱʮλ
.min_g			(bcd_min[19:16]				),//Ӹλ
.min_s			(bcd_min[23:20]				),//ʮλ
.tem_g			((bcd_code[19:16])			),//¶ȸλ
.tem_s      	((bcd_code[23:20])			),//¶ʮλ
.tem_sign   	(temperature_flag			),//¶ȷ
.tem_d			((bcd_code[15:12])			),//¶Сλ				
.oled_csn		(oled_csn					),//OLCDҺʹ
.oled_rst		(oled_rst					),//OLCDҺλ
.oled_dcn		(oled_dcn					),//OLCDָ
.oled_clk		(oled_clk					),//OLCDʱź
.oled_dat		(oled_dat					)//OLCDź
);
//********************************************************************************
wire  [311:0]data;
wire pwm_en;
buzzer  buzzer_lf
(
.tri_uart 	(pwm_en			),//־
.clk       	(clk			),//12MHzϵͳʱ
.clk_buzzer (B1				),//B1LED˸Ƶ
.data_uart 	(data			),//ڽ
.stop      	(display_flag	),//ű־λ
.out       	(beeper			),//ӷ
.rst_n      (rst_n			) //ϵͳλЧ

);
//9600hzƵʣṩڷʹ********************************************************
wire clk_o;
clk_uart  clk_uart_lf
(
.rst_n   (rst_n			),//ϵͳλЧ
.clk_in  (clk          	),//12MHzϵͳʱ
.clk_out (clk_o        	)//9600HZʱ
);		
//ڷ**********************************************************************************
wire uart_en;        //ڷ͵Ŀź
uart_tx  uart_tx_lf 
(
.rst_n      (rst_n				),
.tem_g  	((bcd_code[19:16])	),//¶ȸλ
.tem_s  	((bcd_code[23:20])	),//¶ʮλ
.tem_d  	((bcd_code[15:12])	),//¶Сλ
.clk_tx 	(clk_o          	),//ʱ
.en     	(uart_en			),//ڷͱ־
.uart_out  	(uart_out			)//ڷ
);	
//ڽ*********************************************************************************
uart_rx  uart_rx_lf
(
.rst_n  	(rst_n				),//ϵͳλЧ
.uart_in  	(uart_in			),//ڽ
.clk  		(clk				),//12MHzϵͳʱ
.receive   	(data				),//ڽ
.pwm_en    	(pwm_en				) //־
);
//1HZźģ******************************************************************************
wire clk_1ms;
clk_1ms clk_1ms_lf
(
.clk 		(clk				),//12MHzϵͳʱ
.rst_n  	(rst_n				),//λź
.clk_1ms	(clk_1ms			) //1HZź
);
//ʱģ******************************************************************************
clock clock_lf
(
.hour       (hour				),//Сʱ  
.min_a      (min_a				),//ӼӰ
.min_d      (min_d				),//Ӽ
.clk_1ms    (clk_1ms   			),//1HZź
.clk_500ms  (B1     			),//B1LED˸Ƶ
.hour_out   (hour_out			),//Сʱ
.min_out    (min_out			),//
.rst_n      (rst_n			    ),//λź
.uart_en    (uart_en			)//ڷͱ־
);
//źŵ˸ģ************************************************************************
signal_led  signal_led_lf
(
.clk     (clk					),//12MHzϵͳʱ
.rst_n   (rst_n					),//λź
.led     (B1					)//B1LED˸Ƶ
);
endmodule

